
/**
 * Classe conta Fundos.
 * Tem um como informao: 
 * - o nmero de unidades de participao compradas
 * - o valor de aquisio de cada unidade de participao
 * - o valor actual de cada unidade de participao 
 * (esta informao fica numa varivel de classe por ser igual para todas as instncias)
 * 
 * ATENO: esta classe est incompleta. Serve s para demonstrar polimorfismo.
 * 
 * @author anr
 * @version 05/2007
 */

import java.util.*;
public class ContaFundos extends Conta
{
    private int num_unidades;
    private double valorinicialunidade;
    
    static double valoractual;
    
    /**
     * Construtor de ContaFundos
     */
    public ContaFundos(String numero, String titular, int num_unidades, double valorinicialunidade, GregorianCalendar di, GregorianCalendar ultMov) {
      super(numero, titular, di, ultMov);
      this.valorinicialunidade = valorinicialunidade;
      this.num_unidades = num_unidades;
        
    }
    
    
    /**
     * Construtor de cpia
     */
    
    public ContaFundos(ContaFundos outraConta) {
        super(outraConta); //invocao do construtor de cpia de Conta. 
                          //Ateno que o objecto  visto nesse construtor como sendo do tipo esttico Conta.
        this.valorinicialunidade = outraConta.getValorInicialUnidade();
        this.num_unidades = outraConta.getNumUnidades();
    }
    
    
    public double getValorInicialUnidade() {
        return this.valorinicialunidade;
    }
    
    public int getNumUnidades() {
        return this.num_unidades;
    }
    
    
    /**
     * Mtodo de classe que devolve o valor das unidades de participao
     * 
     */
    
    public static double getValorUnidadeActual() {
        return valoractual;
    }
    
    /**
     * Mtodo de classe que actualiza o valor das unidades de participao
     */
    
     public static void setValorUnidadeActual(double valoract) {
         valoractual = valoract;
     }
    
    /**
     * Implementao do mtodo getValor() que foi herdado como abstracto da superclasse Conta.
     *  multiplicar o nmero de unidades pelo valor actual da unidade.
     */
    
    public double getValor() {
        
        return this.num_unidades * valoractual;
    }     
        
    
    
    
    /**
     * Implementao do mtodo clone.
     */
    
    public ContaFundos clone() {
       return new ContaFundos(this);
    }   
}
