
/**
 * Classe de teste do Banco.
 * 
 * 
 * @author F. Mrio Martins
 * @version (a version number or a date)
 */
import java.io.*;
import java.util.*;
import static java.lang.System.out;

public class TstBanco {
	public static void main(String[] args) {
	    
	    GregorianCalendar c = new GregorianCalendar();
	    
	    
	    
	    Banco meuBanco = new Banco("POO 06/07");
	    
	    
	    Scanner input = new Scanner(System.in);
	    
	    //Criao das Contas
	    
	    ContaOrdem c1 = new ContaOrdem("1","jose",200,new GregorianCalendar(2007,4,20),new GregorianCalendar());
	   	ContaOrdem c2 = new ContaOrdem("2","luis",50,new GregorianCalendar(2007,4,21),new GregorianCalendar()); 
	    ContaOrdem c3 = new ContaOrdem("3","rui",500,new GregorianCalendar(2007,4,18),new GregorianCalendar());
	    
	    
	    ContaPrazo c4 = new ContaPrazo("4","jose",100, (float)0.01,new GregorianCalendar(2007,4,20),new GregorianCalendar());
	    ContaPrazo c5 = new ContaPrazo("5","maria",400, (float)0.01,new GregorianCalendar(2007,4,20),new GregorianCalendar());
	    
	    ContaFundos c6 = new ContaFundos("6","duarte",20, 10, new GregorianCalendar(2007,4,10),new GregorianCalendar());
        ContaFundos c7 = new ContaFundos("7","joao",10, 15, new GregorianCalendar(2007,4,20),new GregorianCalendar());
	    
        
	    //Inserir as contas no Banco
	    
	    meuBanco.criaConta(c1);
	    meuBanco.criaConta(c2);	    
	    meuBanco.criaConta(c3);	  	    
	    meuBanco.criaConta(c4);  
	    meuBanco.criaConta(c5);	    
	    meuBanco.criaConta(c6);	    
	    meuBanco.criaConta(c7);
	   
	    
	   out.println("N de contas: " + meuBanco.numContas());
	   
	   ArrayList<String> codigos = new ArrayList<String>();
	   codigos = meuBanco.listaNumeros();
	  
	   out.println("------- Contas --------");
	   for(String num : codigos) 
	     out.println(meuBanco.daConta(num));
	  
	   
	   
	   //Actualizar o valor da unidade de participao
	   //das contas fundos
	   //invocao do mtodo de classe
	   
	   ContaFundos.setValorUnidadeActual(20.0);
	   
	   
	   // Clculo do dinheiro total que o banco deve aos seus clientes.
	   // Ou seja, o dinheiro que precisaria de ter se todos resatassem agora 
	   // as suas contas.
	   
	   double valor = meuBanco.getTotalDinheiroNecessario();
	   out.println("Dinheiro Necessrio:" + valor);
	   
	   
	   
    }
}